diff --git a/src/gui/MainWidget.cpp b/src/gui/MainWidget.cpp
index 139dd2a4..4bbc7a61 100644
--- a/src/gui/MainWidget.cpp
+++ b/src/gui/MainWidget.cpp
@@ -32,8 +32,6 @@
 #include <QListWidget>
 #ifdef Q_OS_MACOS
     #include <QProcess>
-    #include <QScreen>
-    #include <QWindow>
 #endif
 #ifdef Q_OS_WIN
     #include <QWinThumbnailToolButton>
@@ -62,7 +60,8 @@
 #include <VolWidget.hpp>
 #include <ScreenSaver.hpp>
 #ifdef Q_OS_MACOS
-    #include <QMPlay2MacExtensions.hpp>
+    #include <Carbon/Carbon.h>
+    extern void qt_mac_set_dock_menu(QMenu *);
 #endif
 
 using Functions::timeToStr;
@@ -76,21 +75,6 @@ using Functions::timeToStr;
 
 #include <cmath>
 
-/* MainWidgetTmpStyle -  dock widget separator extent must be larger for touch screens */
-class MainWidgetTmpStyle final : public QCommonStyle
-{
-public:
-    ~MainWidgetTmpStyle() = default;
-
-    int pixelMetric(PixelMetric metric, const QStyleOption *option, const QWidget *widget) const override
-    {
-        const int pM = QCommonStyle::pixelMetric(metric, option, widget);
-        if (metric == QStyle::PM_DockWidgetSeparatorExtent)
-            return pM * 5 / 2;
-        return pM;
-    }
-};
-
 #ifndef Q_OS_MACOS
 static void copyMenu(QMenu *dest, QMenu *src, QMenu *dontCopy = nullptr)
 {
@@ -110,25 +94,13 @@ static void copyMenu(QMenu *dest, QMenu *src, QMenu *dontCopy = nullptr)
 #endif
 
 /* MainWidget */
-MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments) :
+MainWidget::MainWidget(QPair<QStringList, QStringList> &arguments) :
     updater(this)
 {
     QMPlay2GUI.videoAdjustment = new VideoAdjustmentW;
     QMPlay2GUI.shortcutHandler = new ShortcutHandler(this);
     QMPlay2GUI.mainW = this;
 
-    /* Looking for touch screen */
-    for (const QTouchDevice *touchDev : QTouchDevice::devices())
-    {
-        /* Touchscreen found */
-        if (touchDev->type() == QTouchDevice::TouchScreen)
-        {
-            MainWidgetTmpStyle mainWidgetTmpStyle;
-            setStyle(&mainWidgetTmpStyle);
-            break;
-        }
-    }
-
     setObjectName("MainWidget");
 
     settingsW = nullptr;
@@ -284,9 +256,7 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments) :
     connect(playlistDock, SIGNAL(play(const QString &)), &playC, SLOT(play(const QString &)));
     connect(playlistDock, SIGNAL(repeatEntry(bool)), &playC, SLOT(repeatEntry(bool)));
     connect(playlistDock, SIGNAL(stop()), &playC, SLOT(stop()));
-    connect(playlistDock, &PlaylistDock::addAndPlayRestoreWindow, this, [this] {
-        m_restoreWindowOnVideo = true;
-    });
+    connect(playlistDock, SIGNAL(addAndPlayRestoreWindow()), this, SLOT(handleAddAndPlayRestoreWindow()));
 
     connect(seekS, SIGNAL(valueChanged(int)), this, SLOT(seek(int)));
     connect(seekS, SIGNAL(mousePosition(int)), this, SLOT(mousePositionOnSlider(int)));
@@ -320,17 +290,10 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments) :
     connect(&playC, SIGNAL(updateBufferedRange(int, int)), seekS, SLOT(drawRange(int, int)));
     connect(&playC, SIGNAL(updateWindowTitle(const QString &)), this, SLOT(updateWindowTitle(const QString &)));
     connect(&playC, SIGNAL(updateImage(const QImage &)), videoDock, SLOT(updateImage(const QImage &)));
-    connect(&playC, &PlayClass::videoStarted, this, &MainWidget::videoStarted);
-    connect(&playC, &PlayClass::videoNotStarted, this, [this] {
-        m_restoreWindowOnVideo = false;
-    });
+    connect(&playC, SIGNAL(videoNotStarted()), this, SLOT(handleVideoNotStarted()));
+    connect(playlistDock, SIGNAL(addAndPlayRestoreWindow()), this, SLOT(onAddAndPlayRestoreWindow()));
     connect(&playC, SIGNAL(uncheckSuspend()), this, SLOT(uncheckSuspend()));
-    connect(&playC, &PlayClass::setVideoCheckState, this, [this](bool rotate90, bool hFlip, bool vFlip, bool spherical) {
-        menuBar->playback->videoFilters->rotate90->setChecked(rotate90);
-        menuBar->playback->videoFilters->hFlip->setChecked(hFlip);
-        menuBar->playback->videoFilters->vFlip->setChecked(vFlip);
-        menuBar->playback->videoFilters->spherical->setChecked(spherical);
-    });
+    connect(&playC, SIGNAL(setVideoCheckState(bool, bool, bool, bool)), this, SLOT(handleSetVideoCheckState(bool, bool, bool, bool)));
     /**/
 
     if (settings.getBool("MainWidget/TabPositionNorth"))
@@ -390,21 +353,21 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments) :
         if (tabBar && tabBar->property("changeCurrentOnDrag").isValid())
         {
             tabBar->setAcceptDrops(true);
-            tabBar->setChangeCurrentOnDrag(true);
         }
     }
 
     playlistDock->load(QMPlay2Core.getSettingsDir() + "Playlist.pls");
 
     bool noplay = false;
-    for (const auto &argument : asConst(arguments))
+    for (int i = 0; i < arguments.first.size(); ++i) // Iterate over the size of the first QStringList
     {
-        const QString &param = argument.first;
-        const QString &data  = argument.second;
+        const QString &param = arguments.first.at(i);  // Access the elements of the first QStringList
+        const QString &data  = arguments.second.at(i); // Access the corresponding elements of the second QStringList
         noplay |= (param == "open" || param == "noplay");
         processParam(param, data);
     }
-    arguments.clear();
+    arguments.first.clear();  // Clear the first QStringList
+    arguments.second.clear(); // Clear the second QStringList
 
     if (!noplay)
     {
@@ -421,22 +384,11 @@ MainWidget::MainWidget(QList<QPair<QString, QString>> &arguments) :
             playStateChanged(false);
     }
 
-#ifdef Q_OS_MACOS
-    qApp->installEventFilter(this);
-    fileOpenTimer.setSingleShot(true);
-    connect(&fileOpenTimer, &QTimer::timeout, this, &MainWidget::fileOpenTimerTimeout);
-    if (QMPlay2GUI.pipe) // Register media keys only for first QMPlay2 instance
-        QMPlay2MacExtensions::registerMacOSMediaKeys(std::bind(&MainWidget::processParam, this, std::placeholders::_1, QString()));
-#endif
-
     if (settings.getBool("AutoUpdates"))
         updater.downloadUpdate();
 }
 MainWidget::~MainWidget()
 {
-#ifdef Q_OS_MACOS
-    QMPlay2MacExtensions::unregisterMacOSMediaKeys();
-#endif
     QMPlay2Extensions::closeExtensions();
     emit QMPlay2Core.restoreCursor();
     Notifies::finalize();
@@ -557,6 +509,15 @@ void MainWidget::updateWindowTitle(const QString &t)
     title.replace('\n', ' ');
     setWindowTitle(title);
 }
+
+void MainWidget::handleAddAndPlayRestoreWindow() {
+    m_restoreWindowOnVideo = true;
+}
+
+void MainWidget::handleVideoNotStarted() {
+    m_restoreWindowOnVideo = false;
+}
+
 void MainWidget::videoStarted(bool noVideo)
 {
     const bool autoRestoreMainWindowOnVideo = m_restoreWindowOnVideo ? QMPlay2Core.getSettings().getBool("AutoRestoreMainWindowOnVideo") : false;
@@ -693,20 +654,22 @@ void MainWidget::resetSpherical()
 void MainWidget::visualizationFullScreen()
 {
     QWidget *senderW = (QWidget *)sender();
-    const auto maybeGoFullScreen = [this, senderW] {
-        if (!fullScreen)
-        {
-            videoDock->setWidget(senderW);
-            toggleFullScreen();
-        }
-    };
 #ifdef Q_OS_MACOS
-    // On macOS if full screen is toggled to fast after double click, mouse remains in clicked state...
-    QTimer::singleShot(200, maybeGoFullScreen);
+    QTimer::singleShot(200, this, SLOT(maybeGoFullScreen()));
 #else
-    maybeGoFullScreen();
+    maybeGoFullScreen(senderW);
 #endif
 }
+
+void MainWidget::maybeGoFullScreen(QWidget *senderW)
+{
+    if (!fullScreen)
+    {
+        videoDock->setWidget(senderW);
+        toggleFullScreen();
+    }
+}
+
 void MainWidget::hideAllExtensions()
 {
     for (QMPlay2Extensions *QMPlay2Ext : QMPlay2Extensions::QMPlay2ExtensionsList())
@@ -724,11 +687,7 @@ void MainWidget::toggleVisibility()
             toggleFullScreen();
         if (!isTray)
         {
-#ifndef Q_OS_MACOS
             showMinimized();
-#else
-            QMPlay2MacExtensions::setApplicationVisible(false);
-#endif
         }
         else
         {
@@ -764,6 +723,7 @@ void MainWidget::toggleVisibility()
     }
 #endif
 }
+
 void MainWidget::createMenuBar()
 {
     menuBar = QMPlay2GUI.menuBar;
@@ -779,7 +739,7 @@ void MainWidget::createMenuBar()
     connect(menuBar->window->toggleVisibility, SIGNAL(triggered()), this, SLOT(toggleVisibility()));
     connect(menuBar->window->toggleFullScreen, SIGNAL(triggered()), this, SLOT(toggleFullScreen()));
     connect(menuBar->window->toggleCompactView, SIGNAL(triggered()), this, SLOT(toggleCompactView()));
-    connect(menuBar->window->alwaysOnTop, &QAction::triggered, this, &MainWidget::toggleAlwaysOnTop);
+    connect(menuBar->window->alwaysOnTop, SIGNAL(triggered(bool)), this, SLOT(toggleAlwaysOnTop(bool)));
     connect(menuBar->window->close, SIGNAL(triggered()), this, SLOT(close()));
 
     connect(menuBar->playlist->add->address, SIGNAL(triggered()), this, SLOT(openUrl()));
@@ -794,7 +754,7 @@ void MainWidget::createMenuBar()
     connect(menuBar->playlist->newGroup, SIGNAL(triggered()), playlistDock, SLOT(newGroup()));
     connect(menuBar->playlist->renameGroup, SIGNAL(triggered()), playlistDock, SLOT(renameGroup()));
     connect(menuBar->playlist->lock, SIGNAL(triggered()), playlistDock, SLOT(toggleLock()));
-    connect(menuBar->playlist->alwaysSync, &QAction::triggered, playlistDock, &PlaylistDock::alwaysSyncTriggered);
+    connect(menuBar->playlist->alwaysSync, SIGNAL(triggered(bool)), playlistDock, SLOT(alwaysSyncTriggered(bool)));
     connect(menuBar->playlist->delEntries, SIGNAL(triggered()), playlistDock, SLOT(delEntries()));
     connect(menuBar->playlist->delNonGroupEntries, SIGNAL(triggered()), playlistDock, SLOT(delNonGroupEntries()));
     connect(menuBar->playlist->clear, SIGNAL(triggered()), playlistDock, SLOT(clear()));
@@ -931,19 +891,18 @@ void MainWidget::createMenuBar()
     secondMenu->addSeparator();
     // Copy action, because PreferencesRole doesn't show in dock menu.
     QAction *settings = new QAction(menuBar->options->settings->icon(), menuBar->options->settings->text(), menuBar->options->settings->parent());
-    connect(settings, &QAction::triggered, menuBar->options->settings, &QAction::trigger);
+    connect(settings, SIGNAL(triggered()), menuBar->options->settings, SLOT(trigger()));
     secondMenu->addAction(settings);
 
     QAction *newInstanceAct = new QAction(tr("New window"), secondMenu);
-    connect(newInstanceAct, &QAction::triggered, [] {
-        QProcess::startDetached(QCoreApplication::applicationFilePath(), {"-noplay"}, QCoreApplication::applicationDirPath());
-    });
+    connect(newInstanceAct, SIGNAL(triggered()), this, SLOT(createNewWindow()));
     secondMenu->addSeparator();
     secondMenu->addAction(newInstanceAct);
 
     qt_mac_set_dock_menu(secondMenu);
 #endif
 }
+
 void MainWidget::trayIconClicked(QSystemTrayIcon::ActivationReason reason)
 {
 #if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
@@ -966,6 +925,7 @@ void MainWidget::trayIconClicked(QSystemTrayIcon::ActivationReason reason)
     Q_UNUSED(reason)
 #endif
 }
+
 void MainWidget::toggleCompactView()
 {
     if (!isCompactView)
@@ -1004,6 +964,7 @@ void MainWidget::toggleCompactView()
         statusBar->show();
     }
 }
+
 void MainWidget::toggleAlwaysOnTop(bool checked)
 {
     auto flags = windowFlags();
@@ -1016,6 +977,7 @@ void MainWidget::toggleAlwaysOnTop(bool checked)
     if (visible)
         show();
 }
+
 void MainWidget::toggleFullScreen()
 {
     static bool visible, compact_view, tb_movable;
@@ -1082,30 +1044,17 @@ void MainWidget::toggleFullScreen()
         videoDock->fullScreen(true);
         videoDock->show();
 
-#ifdef Q_OS_MACOS
-        menuBar->window->toggleVisibility->setEnabled(false);
-#endif
         menuBar->window->toggleCompactView->setEnabled(false);
         menuBar->window->toggleFullScreen->setShortcuts(QList<QKeySequence>() << menuBar->window->toggleFullScreen->shortcut() << QKeySequence("ESC"));
         fullScreen = true;
 
-#ifndef Q_OS_MACOS
         showFullScreen();
-#else
-        setWindowFlags(Qt::Window | Qt::FramelessWindowHint);
-        setGeometry(window()->windowHandle()->screen()->geometry());
-        QMPlay2MacExtensions::showSystemUi(windowHandle(), false);
-        show();
-#endif
 
         if (playC.isPlaying())
             QMPlay2GUI.screenSaver->inhibit(1);
     }
     else
     {
-#ifdef Q_OS_MACOS
-        menuBar->window->toggleVisibility->setEnabled(true);
-#endif
         menuBar->window->toggleCompactView->setEnabled(true);
         menuBar->window->toggleFullScreen->setShortcuts(QList<QKeySequence>() << menuBar->window->toggleFullScreen->shortcut());
 
@@ -1113,19 +1062,11 @@ void MainWidget::toggleFullScreen()
         fullScreen = false;
 
 #ifndef Q_OS_ANDROID
-#ifdef Q_OS_MACOS
-        QMPlay2MacExtensions::showSystemUi(windowHandle(), true);
-        setWindowFlags(Qt::Window);
-#else
         showNormal();
-#endif // Q_OS_MACOS
         if (maximized)
             showMaximized();
         else
         {
-#ifdef Q_OS_MACOS
-            showNormal();
-#endif
             setGeometry(savedGeo);
         }
 #else // Q_OS_ANDROID
@@ -1168,6 +1109,7 @@ void MainWidget::toggleFullScreen()
     }
     emit QMPlay2Core.fullScreenChanged(fullScreen);
 }
+
 void MainWidget::showMessage(const QString &msg, const QString &title, int messageIcon, int ms)
 {
     if (ms < 1 || !Notifies::notify(title, msg, ms, messageIcon))
@@ -1182,6 +1124,7 @@ void MainWidget::showMessage(const QString &msg, const QString &title, int messa
         messageBox->show();
     }
 }
+
 void MainWidget::statusBarMessage(const QString &msg, int ms)
 {
     statusBar->showMessage(msg, ms);
@@ -1199,14 +1142,17 @@ void MainWidget::openUrl()
 
     }
 }
+
 void MainWidget::openFiles()
 {
     playlistDock->add(QFileDialog::getOpenFileNames(this, tr("Choose files"), QMPlay2GUI.getCurrentPth(playlistDock->getUrl(), true)));
 }
+
 void MainWidget::openDir()
 {
     playlistDock->add(QFileDialog::getExistingDirectory(this, tr("Choose directory"), QMPlay2GUI.getCurrentPth(playlistDock->getUrl())));
 }
+
 void MainWidget::loadPlist()
 {
     QString filter = tr("Playlists") + " (";
@@ -1218,14 +1164,17 @@ void MainWidget::loadPlist()
         return;
     playlistDock->load(QFileDialog::getOpenFileName(this, tr("Choose playlist"), QMPlay2GUI.getCurrentPth(playlistDock->getUrl()), filter));
 }
+
 void MainWidget::savePlist()
 {
     savePlistHelper(tr("Save playlist"), QMPlay2GUI.getCurrentPth(playlistDock->getUrl()), false);
 }
+
 void MainWidget::saveGroup()
 {
     savePlistHelper(tr("Save group"), QMPlay2GUI.getCurrentPth(playlistDock->getUrl()) + playlistDock->getCurrentItemName(), true);
 }
+
 void MainWidget::showSettings(const QString &moduleName)
 {
     if (!settingsW)
@@ -1247,6 +1196,7 @@ void MainWidget::showSettings(const QString &moduleName)
             showSettings(moduleName);
     }
 }
+
 void MainWidget::showSettings()
 {
     showSettings(QString());
@@ -1259,6 +1209,7 @@ void MainWidget::itemDropped(const QString &pth, bool subs)
     else
         playlistDock->addAndPlay(pth);
 }
+
 void MainWidget::browseSubsFile()
 {
     QString dir = Functions::filePath(playC.getUrl());
@@ -1301,6 +1252,7 @@ void MainWidget::setSeekSMaximum(int max)
         seekS->setEnabled(false);
     }
 }
+
 void MainWidget::updatePos(double pos)
 {
     static int currPos;
@@ -1322,6 +1274,7 @@ void MainWidget::updatePos(double pos)
 #endif
     }
 }
+
 void MainWidget::mousePositionOnSlider(int pos)
 {
     statusBar->showMessage(tr("Pointed position") + ": " + timeToStr(pos / 10.0, true), 750);
@@ -1332,6 +1285,7 @@ void MainWidget::newConnection(IPCSocket *socket)
     connect(socket, SIGNAL(readyRead()), this, SLOT(readSocket()));
     connect(socket, SIGNAL(aboutToClose()), socket, SLOT(deleteLater()));
 }
+
 void MainWidget::readSocket()
 {
     IPCSocket *socket = (IPCSocket *)sender();
@@ -1348,6 +1302,10 @@ void MainWidget::readSocket()
         socket->deleteLater();
 }
 
+void MainWidget::createNewWindow() {
+    QProcess::startDetached(QCoreApplication::applicationFilePath(), QStringList() << "-noplay", QCoreApplication::applicationDirPath());
+}
+
 void MainWidget::about()
 {
     if (!aboutW)
@@ -1374,6 +1332,7 @@ void MainWidget::hideMenu(bool h)
     }
 }
 #endif
+
 void MainWidget::lockWidgets(bool l)
 {
     if (fullScreen || isCompactView)
@@ -1405,18 +1364,14 @@ void MainWidget::hideDocksSlot()
             hideDocks();
     }
 }
+
 void MainWidget::doRestoreState(const QByteArray &data)
 {
     if (isMaximized())
     {
         setUpdatesEnabled(false);
-        QTimer::singleShot(0, this, [=] {
-            QTimer::singleShot(0, this, [=] {
-                restoreState(data);
-                setUpdatesEnabled(true);
-                repaint();
-            });
-        });
+        QTimer::singleShot(0, this, SLOT(doRestoreStateStep1()));
+        m_restoreStateData = data; // Store the data for use in later steps
     }
     else
     {
@@ -1424,6 +1379,18 @@ void MainWidget::doRestoreState(const QByteArray &data)
     }
 }
 
+void MainWidget::doRestoreStateStep1()
+{
+    QTimer::singleShot(0, this, SLOT(doRestoreStateStep2()));
+}
+
+void MainWidget::doRestoreStateStep2()
+{
+    restoreState(m_restoreStateData);
+    setUpdatesEnabled(true);
+    repaint();
+}
+
 void MainWidget::uncheckSuspend()
 {
     if (menuBar->player->suspend)
@@ -1486,6 +1453,7 @@ void MainWidget::showToolBar(bool showTB)
         statusBar->hide();
     }
 }
+
 void MainWidget::hideDocks()
 {
     fullScreenDockWidgetState = saveState();
@@ -1595,6 +1563,7 @@ void MainWidget::keyPressEvent(QKeyEvent *e)
     }
     QMainWindow::keyPressEvent(e);
 }
+
 void MainWidget::mouseMoveEvent(QMouseEvent *e)
 {
     if ((fullScreen || isCompactView) && (e->buttons() == Qt::NoButton || videoDock->isTouch))
@@ -1663,12 +1632,14 @@ void MainWidget::mouseMoveEvent(QMouseEvent *e)
     }
     QMainWindow::mouseMoveEvent(e);
 }
+
 void MainWidget::leaveEvent(QEvent *e)
 {
     if (fullScreen || isCompactView)
         QMetaObject::invokeMethod(this, "hideDocksSlot", Qt::QueuedConnection); //Qt5 can't hide docks properly here
     QMainWindow::leaveEvent(e);
 }
+
 void MainWidget::closeEvent(QCloseEvent *e)
 {
     const QString quitMsg = tr("Are you sure you want to quit?");
@@ -1735,12 +1706,14 @@ void MainWidget::closeEvent(QCloseEvent *e)
 
     playC.stop(true);
 }
+
 void MainWidget::moveEvent(QMoveEvent *e)
 {
     if (videoDock->isVisible() && !videoDock->isFloating())
         emit QMPlay2Core.videoDockMoved();
     QMainWindow::moveEvent(e);
 }
+
 void MainWidget::showEvent(QShowEvent *)
 {
     if (!wasShow)
@@ -1759,6 +1732,7 @@ void MainWidget::showEvent(QShowEvent *)
     }
     menuBar->window->toggleVisibility->setText(tr("&Hide"));
 }
+
 void MainWidget::hideEvent(QHideEvent *)
 {
 #ifndef Q_OS_ANDROID
@@ -1776,7 +1750,7 @@ bool MainWidget::eventFilter(QObject *obj, QEvent *event)
     if (tray && obj == tray && event->type() == QEvent::Wheel)
     {
         QWheelEvent *we = static_cast<QWheelEvent *>(event);
-        volW->changeVolume(we->angleDelta().y() / 30);
+        volW->changeVolume(we->delta() / 30);
     }
 #ifdef Q_OS_MACOS
     else if (event->type() == QEvent::FileOpen)
@@ -1798,3 +1772,10 @@ void MainWidget::fileOpenTimerTimeout()
     filesToAdd.clear();
 }
 #endif
+
+void MainWidget::handleSetVideoCheckState(bool rotate90, bool hFlip, bool vFlip, bool spherical) {
+    menuBar->playback->videoFilters->rotate90->setChecked(rotate90);
+    menuBar->playback->videoFilters->hFlip->setChecked(hFlip);
+    menuBar->playback->videoFilters->vFlip->setChecked(vFlip);
+    menuBar->playback->videoFilters->spherical->setChecked(spherical);
+}
diff --git a/src/gui/MainWidget.hpp b/src/gui/MainWidget.hpp
index 2fe04bc5..daaf545c 100644
--- a/src/gui/MainWidget.hpp
+++ b/src/gui/MainWidget.hpp
@@ -42,14 +42,18 @@ class QMPlay2Extensions;
     class QWinTaskbarProgress;
 #endif
 
-class MainWidget final : public QMainWindow
+class MainWidget : public QMainWindow
 {
     friend class QMPlay2GUIClass;
     Q_PROPERTY(bool fullScreen READ getFullScreen)
     Q_OBJECT
 public:
-    MainWidget(QList<QPair<QString, QString>> &argument);
-    ~MainWidget();
+    MainWidget(QPair<QStringList, QStringList> &argument);
+    ~MainWidget() final;
+public slots:
+    void handleAddAndPlayRestoreWindow();
+    void handleVideoNotStarted();
+    void handleSetVideoCheckState(bool rotate90, bool hFlip, bool vFlip, bool spherical);
 private slots:
     void detachFromPipe();
 
@@ -77,6 +81,7 @@ private slots:
     void resetSpherical();
 
     void visualizationFullScreen();
+    void maybeGoFullScreen(QWidget *senderW);
     void hideAllExtensions();
     void toggleVisibility();
     void createMenuBar();
@@ -86,6 +91,7 @@ private slots:
     void toggleFullScreen();
     void showMessage(const QString &, const QString &, int, int);
     void statusBarMessage(const QString &, int ms);
+    void createNewWindow();
 
     void openUrl();
     void openFiles();
@@ -117,12 +123,14 @@ private slots:
 
     void hideDocksSlot();
     void doRestoreState(const QByteArray &data);
+    void doRestoreStateStep1();
+    void doRestoreStateStep2();
 
     void uncheckSuspend();
 private:
     void savePlistHelper(const QString &, const QString &, bool);
 
-    QMenu *createPopupMenu() override;
+    QMenu *createPopupMenu() override final;
 
     void showToolBar(bool);
     void hideDocks();
@@ -135,15 +143,15 @@ private:
     void setWindowsTaskBarFeatures();
 #endif
 
-    void keyPressEvent(QKeyEvent *) override;
-    void mouseMoveEvent(QMouseEvent *) override;
-    void leaveEvent(QEvent *) override;
-    void closeEvent(QCloseEvent *) override;
-    void moveEvent(QMoveEvent *) override;
-    void showEvent(QShowEvent *) override;
-    void hideEvent(QHideEvent *) override;
+    void keyPressEvent(QKeyEvent *) override final;
+    void mouseMoveEvent(QMouseEvent *) override final;
+    void leaveEvent(QEvent *) override final;
+    void closeEvent(QCloseEvent *) override final;
+    void moveEvent(QMoveEvent *) override final;
+    void showEvent(QShowEvent *) override final;
+    void hideEvent(QHideEvent *) override final;
 
-    bool eventFilter(QObject *obj, QEvent *event) override;
+    bool eventFilter(QObject *obj, QEvent *event) override final;
 
 #ifdef Q_OS_MACOS
     void fileOpenTimerTimeout();
@@ -185,6 +193,8 @@ private:
 #endif
     QAction *lockWidgetsAct;
 
+    QByteArray m_restoreStateData; // Temporary storage for the state data
+
     Updater updater;
 
 #ifdef Q_OS_WIN
diff --git a/src/gui/MenuBar.cpp b/src/gui/MenuBar.cpp
index b3ea2162..7210239d 100644
--- a/src/gui/MenuBar.cpp
+++ b/src/gui/MenuBar.cpp
@@ -366,27 +366,6 @@ MenuBar::Playback::VideoFilters::VideoFilters(QMenu *parent) :
     widgetAction->setDefaultWidget(QMPlay2GUI.videoAdjustment);
     QMPlay2GUI.videoAdjustment->setObjectName(videoAdjustmentMenu->title().remove('&'));
     videoAdjustmentMenu->addAction(widgetAction);
-#ifdef Q_OS_MACOS
-    // Update visibility and update geometry of video adjustment widget
-    connect(videoAdjustmentMenu, &VideoFilters::aboutToShow, [] {
-        QWidget *parent = QMPlay2GUI.videoAdjustment->parentWidget();
-        if (parent)
-        {
-            const QString parentObject = parent->metaObject()->className();
-            if (parentObject == "QMacNativeWidget")
-            {
-                QMPlay2GUI.videoAdjustment->update();
-                QMPlay2GUI.videoAdjustment->show();
-            }
-            if (parentObject == "QMacNativeWidget" || parentObject == "QMenu")
-            {
-                QTimer::singleShot(1, [parent] {
-                    QMPlay2GUI.videoAdjustment->setGeometry(parent->rect());
-                });
-            }
-        }
-    });
-#endif
     /**/
     addSeparator();
     newAction(VideoFilters::tr("&Spherical view"), this, spherical, true, QIcon(), true);
diff --git a/src/gui/OSDSettingsW.cpp b/src/gui/OSDSettingsW.cpp
index 7b988cbd..b6a67ca1 100644
--- a/src/gui/OSDSettingsW.cpp
+++ b/src/gui/OSDSettingsW.cpp
@@ -38,7 +38,7 @@ static void appendColon(const QObjectList &objects)
 void OSDSettingsW::init(const QString &prefix, int a, int b, int c, int d, int e, int f, double g, double h, const QColor &i, const QColor &j, const QColor &k)
 {
     Settings &QMPSettings = QMPlay2Core.getSettings();
-    QMPSettings.init(prefix + "/FontName", QGuiApplication::font().family());
+    QMPSettings.init(prefix + "/FontName", QFontComboBox().currentText());
     QMPSettings.init(prefix + "/FontSize", a);
     QMPSettings.init(prefix + "/Spacing", b);
     QMPSettings.init(prefix + "/LeftMargin", c);
diff --git a/src/gui/OtherVFiltersW.cpp b/src/gui/OtherVFiltersW.cpp
index 6d449b42..b4136468 100644
--- a/src/gui/OtherVFiltersW.cpp
+++ b/src/gui/OtherVFiltersW.cpp
@@ -37,7 +37,7 @@ OtherVFiltersW::OtherVFiltersW(bool hw) :
         for (const QString &filter : QMPlay2Core.getSettings().getStringList("VideoFilters"))
         {
             videoFilters.first += filter.mid(1);
-            videoFilters.second += filter.leftRef(1).toInt();
+            videoFilters.second += filter.left(1).toInt();
         }
 
         for (int i = 0; i < videoFilters.first.count(); ++i)
diff --git a/src/gui/PlayClass.cpp b/src/gui/PlayClass.cpp
index 1138db76..5b103071 100644
--- a/src/gui/PlayClass.cpp
+++ b/src/gui/PlayClass.cpp
@@ -311,14 +311,14 @@ void PlayClass::seek(double pos, bool allowAccurate)
 void PlayClass::chStream(const QString &s)
 {
     if (s.startsWith("audio"))
-        chosenAudioStream = s.rightRef(s.length() - 5).toInt();
+        chosenAudioStream = s.rightRef(s.length() - 5).toString().toInt();
     else if (s.startsWith("video"))
-        chosenVideoStream = s.rightRef(s.length() - 5).toInt();
+        chosenVideoStream = s.rightRef(s.length() - 5).toString().toInt();
     else if (s.startsWith("subtitles"))
-        chosenSubtitlesStream = s.rightRef(s.length() - 9).toInt();
+        chosenSubtitlesStream = s.rightRef(s.length() - 9).toString().toInt();
     else if (s.startsWith("fileSubs"))
     {
-        int idx = s.rightRef(s.length() - 8).toInt();
+        int idx = s.rightRef(s.length() - 5).toString().toInt();
         if (fileSubsList.count() > idx)
             loadSubsFile(fileSubsList[idx]);
     }
diff --git a/src/gui/PlayClass.hpp b/src/gui/PlayClass.hpp
index 41e4e629..bc4152ed 100644
--- a/src/gui/PlayClass.hpp
+++ b/src/gui/PlayClass.hpp
@@ -44,7 +44,7 @@ enum
     SEEK_REPEAT = -3
 };
 
-class PlayClass final : public QObject
+class PlayClass : public QObject
 {
     Q_OBJECT
     friend class DemuxerThr;
@@ -53,7 +53,7 @@ class PlayClass final : public QObject
     friend class AudioThr;
 public:
     PlayClass();
-    ~PlayClass();
+    ~PlayClass() final;
 
     Q_SLOT void play(const QString &);
     Q_SLOT void stop(bool quitApp = false);
diff --git a/src/gui/PlaylistDock.cpp b/src/gui/PlaylistDock.cpp
index f2872ab0..29e5de72 100644
--- a/src/gui/PlaylistDock.cpp
+++ b/src/gui/PlaylistDock.cpp
@@ -56,7 +56,7 @@ PlaylistDock::PlaylistDock() :
 
     connect(list, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(itemDoubleClicked(QTreeWidgetItem *)));
     connect(list, SIGNAL(returnItem(QTreeWidgetItem *)), this, SLOT(addAndPlay(QTreeWidgetItem *)));
-    connect(list, &PlaylistWidget::itemExpanded, this, &PlaylistDock::maybeDoQuickSync, Qt::QueuedConnection); // Must be queued to not crash at startup in some cases
+    connect(list, SIGNAL(itemExpanded(QTreeWidgetItem *)), this, SLOT(maybeDoQuickSync(QTreeWidgetItem *)), Qt::QueuedConnection);
     connect(list, SIGNAL(visibleItemsCount(int)), this, SLOT(visibleItemsCount(int)));
     connect(list, SIGNAL(addStatus(bool)), findE, SLOT(setDisabled(bool)));
     connect(findE, SIGNAL(textChanged(const QString &)), this, SLOT(findItems(const QString &)));
diff --git a/src/gui/PlaylistWidget.cpp b/src/gui/PlaylistWidget.cpp
index 87164c7c..3c3a38bc 100644
--- a/src/gui/PlaylistWidget.cpp
+++ b/src/gui/PlaylistWidget.cpp
@@ -57,20 +57,6 @@ static inline MenuBar::Playlist *playlistMenu()
     return QMPlay2GUI.menuBar->playlist;
 }
 
-/* PlaylistItem class */
-class PlaylistItem : public QTreeWidgetItem
-{
-public:
-    bool operator <(const QTreeWidgetItem &other) const override
-    {
-        if (treeWidget() && treeWidget()->sortColumn() == 2)
-        {
-            return (data(2, Qt::UserRole) < other.data(2, Qt::UserRole));
-        }
-        return QTreeWidgetItem::operator <(other);
-    }
-};
-
 /* UpdateEntryThr class */
 UpdateEntryThr::UpdateEntryThr(PlaylistWidget &pLW) :
     pendingUpdates(0),
@@ -595,7 +581,7 @@ PlaylistWidget::PlaylistWidget() :
     setAnimated(true);
     header()->setStretchLastSection(false);
     setHeaderHidden(true);
-    header()->setSectionResizeMode(0, QHeaderView::Stretch);
+    header()->setResizeMode(0, QHeaderView::Stretch);
     header()->hideSection(1);
     setItemsResizeToContents(true);
     setIconSize({22, 22});
@@ -608,7 +594,7 @@ PlaylistWidget::PlaylistWidget() :
     connect(&animationTimer, SIGNAL(timeout()), this, SLOT(animationUpdate()));
     connect(&addTimer, SIGNAL(timeout()), this, SLOT(addTimerElapsed()));
     connect(&addThr, SIGNAL(status(bool)), this, SIGNAL(addStatus(bool)));
-    connect(playlistMenu(), &MenuBar::Playlist::aboutToShow, this, &PlaylistWidget::createExtensionsMenu);
+    connect(playlistMenu(), SIGNAL(aboutToShow()), this, SLOT(createExtensionsMenu()));
 }
 
 QString PlaylistWidget::getUrl(QTreeWidgetItem *tWI) const
@@ -622,7 +608,7 @@ void PlaylistWidget::setItemsResizeToContents(bool b)
 {
     const QHeaderView::ResizeMode rm = b ? QHeaderView::ResizeToContents : QHeaderView::Fixed;
     for (int i = 1; i <= 2; ++i)
-        header()->setSectionResizeMode(i, rm);
+        header()->setResizeMode(i, rm);
 }
 
 void PlaylistWidget::sortCurrentGroup(int column, Qt::SortOrder sortOrder)
@@ -915,7 +901,7 @@ void PlaylistWidget::setEntryFont(QTreeWidgetItem *tWI, const int flags)
 
 QTreeWidgetItem *PlaylistWidget::newGroup(const QString &name, const QString &url, QTreeWidgetItem *parent, int insertChildAt, QStringList *existingEntries)
 {
-    QTreeWidgetItem *tWI = new PlaylistItem;
+    QTreeWidgetItem *tWI = new QTreeWidgetItem;
 
     tWI->setFlags(tWI->flags() | Qt::ItemIsEditable);
     QMPlay2GUI.setTreeWidgetItemIcon(tWI, url.isEmpty() ? *QMPlay2GUI.groupIcon : *QMPlay2GUI.folderIcon, 0, this);
@@ -928,9 +914,10 @@ QTreeWidgetItem *PlaylistWidget::newGroup(const QString &name, const QString &ur
     QMetaObject::invokeMethod(this, "insertItem", Q_ARG(QTreeWidgetItem *, tWI), Q_ARG(QTreeWidgetItem *, parent), Q_ARG(int, insertChildAt));
     return tWI;
 }
+
 QTreeWidgetItem *PlaylistWidget::newEntry(const Playlist::Entry &entry, QTreeWidgetItem *parent, const Functions::DemuxersInfo &demuxersInfo, int insertChildAt, QStringList *existingEntries)
 {
-    QTreeWidgetItem *tWI = new PlaylistItem;
+    QTreeWidgetItem *tWI = new QTreeWidgetItem;
 
     QIcon icon;
     Functions::getDataIfHasPluginPrefix(entry.url, nullptr, nullptr, &icon, nullptr, demuxersInfo);
